# Getting Started with Kieker Adapter for Descartes Query Language (DQL)

## Installation

After Cloning the project into your eclipse workspace you should be able to run it as an osgi bundle like all existing DQL plugins. By selecting the targetplatform _kieker4dql_ in the provided project _tools.descartes.dql.connector.kieker.releng.platform_,
all dependencies needed to run the adapter will be downloaded and included automatically. The adapter registers itself as a DQL connector unter the name _kieker_ which can now be chosen in the USING clause of DQL queries.

Additionally download a kieker distribution from the following location (the adapter was tested with kieker 1.13):

http://kieker-monitoring.net/download/

## Running Example Queries

The project comes with two examples that can be found under _tools.descartes.dql.connector.kieker.examples_.

The **helloWorld example** shows monitoring and analysis with a simple jar application.
Just load the project into your new eclipse and set the path to your kieker distribution in the _helloWorld.properties_ file (see also [Adapter Configuration](#config)).
Then run one of the *.dql files contained in the project by chosing _Run as -> DQL Launcher_.

The **JPetStore example** shows how Analysis can be done with logfiles that have not been produced by the adapter itself. These logfiles resulted during our evaluations with the JPetstore application and can be found in the _traceFiles_ folder of the project.
This example can be directly run without changing the properties file.

## <a name="config"></a> Adapter Configuration

If you want to change the behaviour of the adapter run you may edit a projects properties file. The following properties can be customized:

| Key | Example Value | Description |
| -------- | -------- | -------- |
| kieker.maxRunTimeInSeconds | 30 | maximum time in seconds to wait until monitoring is terminated |
| kieker.monitoring.default.properties  | META-INF/kieker.monitoring.default.properties   | Path to default monitoring configuration to use as a base |
| kieker.kiekerLocation  | C://kieker-1.13-SNAPSHOT   | Path to the kieker distribution to use |
| kieker.applicationJarFile  | helloWorld.jar  | Path to the target application jar file to monitor |
| kieker.log.directory  | logs  | Path to the location of the logfiles. If empty, adapter creates logfiles files there first|
| kieker.log.hostname  | KIEKER-DEMO-SRV   | Name of the Host that produced the records of interests (used for logfiles analysis)|

Note that the entries need to be added in Java properties style without quotes, for example _kieker.kiekerLocation=C://kieker-1.13-SNAPSHOT_.
All Paths can be either absolute or relative to the location of the properties file.

## Final Remarks
More information at
http://desartes.tools/dql/

Please cite the following to honor development efforts 
Matthias Blohm, Maksim Pahlberg, Sebastian Vogel, Jürgen Walter, and Dusan Okanovic. Kieker4DQL: Declarative Performance Measurement. In Proceedings of the 2016 Symposium on Software Performance (SSP), Kiel, Germany, November 8-9, 2016.


